<CsoundSynthesizer>;

;By Bjrn Houdorf, December 2011

      

      

;The buzz opcode can have a lot of harmonic overtones 

;and frequency modulation of the buzz opcode gives even more overtones

      

;4 different voices plays at the same time, forming strange "cords" that uses glissando/portamento ;to move from one cord to the next

      

;This .csd file is regenerative, everytime you run it, it should show a different performance

             

	<CsOptions>

      

    </CsOptions>

    <CsInstruments>

     

      sr     = 44100

      kr     = 4410

      nchnls = 2

      0dbfs  = 1

        

;*********************************************************************************

; Global initializations ("Instrument 0")



                seed      0 ; New pitches, every time you run this file

                  

gkfreq1         init      0 

gkfreq2         init      0

gkfreq3         init      0

gkfreq4         init      0 



gimidia1        init     60; The 4 voices starts at different midi frequencies

gimidib1        init     60

gimidia2        init     64

gimidib2 		init     64

gimidia3        init     67

gimidib3        init     67

gimidia4        init     70

gimidib4        init     70



; Function Table

giFt1 ftgen  0, 0, 16384, 10, 1; Sine wave





instr 1; Master control pitch for instrument 2



test:

	idurtest random 6, 30; Duration of each test loop

	timout 0, idurtest, execute



reinit test

			

execute:

	gimidia1 = gimidib1

	ital1 random -4, 4

	gimidib1 = gimidib1 + ital1

	

	gimidia2 = gimidib2

	ital2 random -4, 4

	gimidib2 = gimidib2 + ital2

	

	gimidia3 = gimidib3

	ital3 random -4, 4

	gimidib3 = gimidib3 + ital3

	

	gimidia4 = gimidib4

	ital4 random -4, 4

	gimidib4 = gimidib4 + ital4

	

	idiv = 8

	

	idurx        =     0.01 ; Micro end segment to create a held final frequency value 

	ifreq1a      =     cpsmidinn(gimidia1)

	ifreq1b      =     cpsmidinn(gimidib1)

	gkfreq1 linseg ifreq1a, idurtest/idiv, ifreq1b, idurx, ifreq1b ;Portamento frequency ramp



	ifreq2a      =     cpsmidinn(gimidia2)

	ifreq2b      =     cpsmidinn(gimidib2)

	gkfreq2 linseg ifreq2a, idurtest/idiv, ifreq2b, idurx, ifreq2b 





	ifreq3a      =     cpsmidinn(gimidia3)

	ifreq3b      =     cpsmidinn(gimidib3)

	gkfreq3 linseg ifreq3a, idurtest/idiv, ifreq3b, idurx, ifreq3b





	ifreq4a      =     cpsmidinn(gimidia4)

	ifreq4b      =     cpsmidinn(gimidib4)

	gkfreq4 linseg ifreq4a, idurtest/idiv, ifreq4b, idurx, ifreq4b 

endin                   



instr 2 ; Oscillators

iamp		=		p4

irise	    =		p5 

idur		=		p3

idec		=		p6

kamp        =       p7 

imodfrq     =       p8

iharm       =       p9 ; Number of harmonics for the buzz opcode



ky  		 linen     iamp, irise, idur, idec



kampfreq = 2

kampa        oscili    kamp, kampfreq, giFt1



klfo1        oscili    kampa, imodfrq, giFt1, 0   ; Different phase for the 4 voices

klfo2        oscili    kampa, imodfrq, giFt1, 0.25 

klfo3        oscili    kampa, imodfrq, giFt1, 0.50 

klfo4        oscili    kampa, imodfrq, giFt1, 0.75 



kzfrq = 0.1 ; how fast will the amplitude of the "buzz'es" oscillate



kx1  		 oscili    0.5, kzfrq, giFt1, 0    ; Amplitude between -0.5 and 0.5

kx2          oscili    0.5, kzfrq, giFt1, 0.25 

kx3          oscili    0.5, kzfrq, giFt1, 0.50 

kx4          oscili    0.5, kzfrq, giFt1, 0.75 



k1=kx1+0.5; Add 0.5 so amplitude oscillate between 0 and 1

k2=kx2+0.5

k3=kx3+0.5

k4=kx4+0.5



itilf random -1, 1; Minimize interference between chorus oscillators



asig11      buzz      ky*k1, (1.99*gkfreq1)+itilf+klfo1, iharm, giFt1

asig12      buzz      ky*k1,       gkfreq1       +klfo1, iharm, giFt1; Voice 1

asig13      buzz      ky*k1, (1.01*gkfreq1)+itilf+klfo1, iharm, giFt1

aa1 =asig11+asig12+asig13



asig21      buzz      ky*k2, (1.99*gkfreq2)+itilf+klfo2, iharm, giFt1

asig22      buzz      ky*k2,       gkfreq2       +klfo2, iharm, giFt1; Voice 2

asig23      buzz      ky*k2, (1.01*gkfreq2)+itilf+klfo2, iharm, giFt1

aa2 =asig21+asig22+asig23



asig31      buzz      ky*k3, (1.99*gkfreq3)+itilf+klfo3, iharm, giFt1

asig32      buzz      ky*k3,       gkfreq3       +klfo3, iharm, giFt1; Voice 3

asig33      buzz      ky*k3, (1.01*gkfreq3)+itilf+klfo3, iharm, giFt1

aa3 =asig31+asig32+asig33



asig41      buzz      ky*k4, (1.99*gkfreq4)+itilf+klfo4, iharm, giFt1

asig42      buzz      ky*k4,       gkfreq4       +klfo4, iharm, giFt1; Voice 4

asig43      buzz      ky*k4, (1.01*gkfreq4)+itilf+klfo4, iharm, giFt1



aa4 =asig41+asig42+asig43

outs aa1+aa3, aa2+aa4

        

endin 



	</CsInstruments>

	

   	<CsScore>

   		

; Master control instrument

; Inst start  dur     

   i1    0    99999      

                      

; Oscillators

; inst	  start	   idur	   iamp	  irise	   idec	  kamp	imodfrq   iharm

   i2	   0	   99999    0.3		4		20    0.10     7        16

   

	</CsScore>   

			

</CsoundSynthesizer>

    <bsbPanel>

 <label>Widgets</label>

 <objectName/>

 <x>72</x>

 <y>179</y>

 <width>400</width>

 <height>200</height>

 <visible>true</visible>

 <uuid/>

 <bgcolor mode="nobackground">

  <r>231</r>

  <g>46</g>

  <b>255</b>

 </bgcolor>

 <bsbObject version="2" type="BSBVSlider">

  <objectName>slider1</objectName>

  <x>5</x>

  <y>5</y>

  <width>20</width>

  <height>100</height>

  <uuid>{a4ad9923-891a-4833-8041-218cc52f9fda}</uuid>

  <visible>true</visible>

  <midichan>0</midichan>

  <midicc>-3</midicc>

  <minimum>0.00000000</minimum>

  <maximum>1.00000000</maximum>

  <value>0.00000000</value>

  <mode>lin</mode>

  <mouseControl act="jump">continuous</mouseControl>

  <resolution>-1.00000000</resolution>

  <randomizable group="0">false</randomizable>

 </bsbObject>

</bsbPanel>

<bsbPresets>

</bsbPresets>

<MacGUI>

ioView nobackground {59367, 11822, 65535}

ioSlider {5, 5} {20, 100} 0.000000 1.000000 0.000000 slider1

</MacGUI>

